/*
 * Dateiverwaltung: Kopieren einer Datei
 * stdin, stdout
 * rewind(), feof()
 * fgetc(), fputc(), getchar(), putchar()
 */

# include <stdio.h>

void WEITER();

/* Kopierunterprogramme */
void copy( FILE *, FILE *);
void page( FILE *);

int main( int i, char *z[])
{
  FILE *d1, *d2; 

  if( i == 1 )
  {
    printf
      ( "EINGABE von der Tastatur/Abbruch mit ^D\n");
    printf( "AUSGABE am Bildschirm.\n");
    WEITER();
    page( stdin);
    return 0;
  }
  else
  if(( d1 = fopen( z[ 1], "r")) == NULL)
  {
    printf( "FEHLER: ");
    printf( "%s konnte nicht eroeffnet werden!\n",
            z[ 1]);
    return 1;
  }

  if( i == 2 )
  {
    printf( "Ausgabe am Bildschirm:\n\n");
    page( d1);
    fclose( d1);
    return 0;
  }
  else
  if(( d2 = fopen( z[ 2], "w+")) == NULL)
  {
    printf( "FEHLER: ");
    printf( "Datei %s konnte nicht angelegt werden!\n",
            z[ 2]);
    return 2;
  }

  copy( d1, d2);

  /* Kontrollausdruck */
  printf( "KOPIERT wurde von \"%s\" nach \"%s\".\n",
          z[ 1], z[ 2]);
  printf( "Ausgabe der Datei \"%s\" am Bildschirm.\n",
          z[ 2]);

  WEITER();
  rewind( d2);      /* Positionierung auf den Anfang */
  page( d2);                /* Ausgabe am Bildschirm */

  fclose( d1);
  fclose( d2);

  return 0;
}

void WEITER()
{
  printf( "   Weiter mit <ENTER>"); getchar(); return;
}

void copy( FILE *f1, FILE *f2)     /* Kopierfunktion */
{
  char zeich;

  while( 1)
  {
    zeich = fgetc( f1);
    if( feof( f1)) break;
    fputc( zeich, f2);
  }
  printf( "\n");

  return;
}

void page( FILE *f1)/* seitenweise Bildschirmausgabe */
{
  int j = 0; char zeich;

  while( 1)
  {
    zeich = fgetc( f1);
    if( feof( f1)) break;
    if(( zeich == '\x0A') && !( ++j % 23)) WEITER();
    putchar( zeich);
  }
  printf( "\n");

  return;
}
