/*
 * Implementation zum Header matrix.c:
 * Zugriff auf Matrizen ueber Zeiger auf Zeiger
 */

# include <stdlib.h>
# include "matrix.h"

double **initMatrix
  ( unsigned int Zeilenzahl, unsigned int Spaltenzahl)
{
  double **matrix, *p; int i;

            /* Zeiger auf Feld von Zeigern ( Zeilen )*/
  matrix = ( double **) malloc
                      ( sizeof( double*) * Zeilenzahl);

                               /* Zeiger auf Matrix, */
           /*zeilenweise hintereinander abgespeichert*/
  matrix[ 0] = ( double *) malloc
         ( sizeof( double) * Zeilenzahl * Spaltenzahl);

                               /* Zeiger auf 2.Zeile */
  p = matrix[0] + Spaltenzahl;
                /* Eintrag der Zeiger auf die Zeilen */
  for( i = 1; i < Zeilenzahl; i++, p += Spaltenzahl)
    matrix[ i] = p;

  return matrix;
}


void freeMatrix( double **matrix)
{ free( *matrix);
  free( matrix);
  return;
}
