/*
 * Polarkoordinaten  ->  kartesische Koordinaten
 */

# include <stdio.h>
# include <math.h>                        /* sin cos */

# define M_PI 3.141593

                   /* Deklaration eines Strukturtyps */
struct kartes{ float x, y;};

                   /* Deklaration eines Strukturtyps */
struct polar{ float rho, phi;};

        /* Funktion mit einer Struktur als Parameter */
             /* und einer Struktur als Funktionswert */
struct kartes kartesisch( struct polar);

int main()
{
  struct polar a;    /* Deklaration einer Struktur a */
  struct kartes b;   /* Deklaration einer Struktur b */


                     /* Zugriff auf Strukturelemente */
  printf( "Polarkoordinaten (Abstand/Winkel): ");
  scanf( "%f%f", &a.rho, &a.phi);

                                  /* Funktionsaufruf */
  /* mit Struktur als Argument und als Funktionswert */
  b = kartesisch( a);

                     /* Zugriff auf Strukturelemente */
  printf( "\nKartesischen Koordinaten : (%f,%f).\n",
            b.x, b.y);

  return 0;
}


/*
 * Koordinatenumrechnung
 */
struct kartes kartesisch( struct polar p)
{
  struct kartes k;

  p.phi *= M_PI / 180;   /* Winkelmass --> Bogenmass */
  k.x = p.rho * cos( p.phi);           /* Umrechnung */
  k.y = p.rho * sin( p.phi);

  return k;
}

