/*
 * rechner.c:
 * Einfacher Rechner fuer Grundrechenarten.
 */
# include <stdio.h>

int main()
{
  double Operand1, Operand2;
  char op[ 2];               /* 2. Komponente fr \0 */

  printf( "Einfacher Tischrechner\n");
  printf( "Eingabe: Operand1 Operator Operand2\n");
  printf( "Abschluss: ^d\n");     /* Beendet Eingabe */

  while( scanf( "%lf %1s %lf",
                &Operand1, op, &Operand2) != EOF)
          /* EOF Eingabeende bzw. Dateiende erreicht */
  {
    switch( op[ 0])            /* Fallunterscheidung */
    {
      case '+': Operand1 += Operand2; break;
      case '-': Operand1 -= Operand2; break;
      case '*': Operand1 *= Operand2; break;
      case '/': if( Operand2 )
                {
                  Operand1 /= Operand2; break;
                }
      default : printf( "FEHLER <RECHNER>\n");
                continue;
    }
    printf( " = %g\n", Operand1);
  }
  return 0;
}
