/*
 * Exponentialfunktion e hoch x
 * Aufruf gcc -Wall -O -ansi exptab.c -o exptab -lm
 * tabelliert Zwischenergebnisse
 */

# include <stdio.h>
# include <math.h>       /* mathematische Funktionen */

double myexp( double);        /* Exponentialfunktion */

/*
 * Rahmenprogramm zur Exponentialfunktion
 */

int main()
{
  double x;                              /* Argument */
  char c[ 2];                         /* Abbruch j/n */

/* Vorbereitung Ueberschrift */
  printf( "\nExponentialfunktion - e hoch x  -\n");

  do
  {
/* Eingabe */
    printf( "\nx = ");
    scanf( "%lf", &x);

/* Verarbeitung und Ausgabe*/
/* Vergleich mit Standardfunktion aus <math.h> */
    printf("e ^ %g = %g, %g\n", x, myexp( x), exp( x));

/* Nachbereitung */
    printf( "Noch einmal j/n? ");
    scanf( "%1s", c);
  } while( c[ 0] == 'j');

  return 0;
}

/*
 * Exponentialfunktion (Reihenentwicklung)
 * e hoch x = 1 + x + x hoch 2 / 2! + x hoch 3 / 3! ...
 */

double myexp( double xx)
{
  double summeAlt, summeNeu = 1, summand = 1;
  int i = 1, j = 0;
                        /* Testausdruck-Ueberschrift */
  printf( "\n%3s%25s%25s%25s\n",
          "i", "summand", "summeAlt", "summeNeu");

  do                            /* Reihenentwicklung */
  { summand *= xx / i++;

    summeAlt = summeNeu;
    summeNeu += summand;
                                     /* Testausdruck */
    printf( "%3d%25.10g%25.10g%25.10g\n",
             i, summand, summeAlt, summeNeu);

    j++;                                /* Blaettern */
    if( j == 20){ j = 0; fflush( stdin); getchar();}

  } while(( summeNeu != summeAlt) /*&& (i < 100)*/);

  return summeAlt;
}
