/*
 * Potenz x hoch k
 */

# include <stdio.h>

double mypow( float, unsigned int);/* Potenzfunktion */

/*
 * Rahmenprogramm zur Potenzberechnung
 */

int main()
{
  float x;                                  /* Basis */
  unsigned int k;                        /* Exponent */
  double p;                                /* Potenz */
  char c[ 2];                        /* Abbruch: j/n */

/* Vorbereitung                         Ueberschrift */
  printf( "\nPotenz  -  p = x hoch k  -\n");

/* Eingabe */
  do                                   /* Eingabe: x */
  {
    printf( "\nx = "); scanf( "%f", &x);
                                       /* Eingabe: k */
    printf( "\nk = "); scanf( "%d", &k);

/* Verarbeitung */
    p = mypow( x, k);            /* Potenzberechnung */

/* Ausgabe */
    printf( "\n%f hoch %d = %f\n", x , k, p);
                                       /* Ausgabe: p */

/* Nachbereitung */
    printf( "Noch einmal j/n? ");
    scanf( "%1s", c);
  } while( c[ 0] == 'j');

  return 0;
}


/*
 * Potenzfunktion
 */

double mypow( float xx, unsigned int kk)
{
  double pp = 1;

/* while - Schleife:
  while( kk > 0){ pp *= xx; kk--;}
*/

/* for-Schleife: */
  for(; kk > 0; kk--) pp *= xx;

  return pp;
}
